#ifndef CONE_H_
#define CONE_H_

#include "nv_math.h"
#include "nv_algebra.h"
#include "SceneObject.h"

class Cone : public SceneObject
{
private:
	vec3 pos;
	double radius;
	double height;
	
	static const double threshold;
	
	
public:
	Cone (vec3 pos, double radius, double height, mat4 transformation, vec3 ambient, vector<Light> lights,
		  vec3 matDiffuse, vec3 matSpecular, vec3 matEmissive, double shininess, double reflective, double refractive);
	void intersect( Ray &ray);
	int solveQuadratic( double a, double b, double c, double *r0, double *r1);
	Cone & operator = (const Cone & rhs);
};

#endif