#include <cstdlib>
#include "Light.h"

const int Light::point = 0;
const int Light::directional = 1;

Light::Light( double r, double g, double b, double x, double y, double z, int type,
	      double constantAttenuation, double linearAttenuation, double quadraticAttenuation ) :
	type( type ), 
	constantAttenuation( constantAttenuation ),
	linearAttenuation( linearAttenuation ),
	quadraticAttenuation( quadraticAttenuation ),
	coords( vec3( x, y, z ) ),
	color( vec3( r, g, b ) )
{
	// reverse direction of coords if distant light to save later computation
	if ( type == Light::directional )
		coords = -1 * coords;
}

Light & Light::operator = ( const Light & rhs )
{
	this->type = rhs.type;
	this->constantAttenuation = rhs.constantAttenuation;
	this->linearAttenuation = rhs.linearAttenuation;
	this->quadraticAttenuation = rhs.quadraticAttenuation;
	this->coords = rhs.coords;
	this->color = rhs.color;

	return *this;
}

