#ifndef MATERIAL_H_
#define MATERIAL_H_

#include "nv_math.h"
#include "nv_algebra.h"

class Material
{
private:
	vec3 diffuse;
	vec3 specular;
	vec3 emissive;
	double shininess;
	double reflective;
	double refractive;
	double refractiveIndex;

public:
	Material();
	//Material( vec3 &diffuse, vec3 &specular, vec3 &emissive, double shininess, double reflective);
	Material( vec3 &diffuse, vec3 &specular, vec3 &emissive, double shininess, double reflective = 0.0, 
			double refractive = 0.0, double refractiveIndex = 1.0 );
	inline vec3 getDiffuse() { return diffuse; }
	inline vec3 getSpecular() { return specular; }
	inline vec3 getEmissive() { return emissive; }
	inline double getShininess() { return shininess; }
	inline double getReflective() { return reflective; }
	inline double getRefractive() { return refractive; }
	inline double getRefractiveIndex() { return refractiveIndex; }

	Material & operator = ( const Material & rhs );
};

#endif

