#ifndef SPHERE_H_
#define SPHERE_H_

#include "nv_math.h"
#include "nv_algebra.h"
#include "SceneObject.h"

class Sphere : public SceneObject
{
private:
	vec3 pos;
	double radius;

	static const double threshold;

public:
	Sphere( vec3 pos, double radius, mat4 transformation, vec3 ambient, vector<Light> lights,
	     vec3 matDiffuse, vec3 matSpecular, vec3 matEmissive, double shininess, double reflective, double refractive );
	void intersect( Ray &ray );

	Sphere & operator = ( const Sphere & rhs );
};

#endif
