#ifndef TRIANGLE_H_
#define TRIANGLE_H_

#include "debug.h"

#include <cstdlib>

#include "nv_math.h"
#include "nv_algebra.h"
#include "Light.h"
#include "Ray.h"
#include "SceneObject.h"
#include "Vertex.h"

class Triangle : public SceneObject
{
private:
	vec3 normal; // store so don't re-compute every frame
	double Kr;

	static const double Triangle::threshold;
public:
	// vertices for constructor must be CCW winding
	Triangle( Vertex v1, Vertex v2, Vertex v3, mat4 transformation,
		  vec3 ambient, vector<Light> lights, vec3 matDiffuse, vec3 matSpecular, 
		  vec3 matEmissive, double shininess, double reflective, double refractive );
	void setNormal( vec3 normal );
	void intersect( Ray &ray );
};

#endif

