
#include <fstream>
#include <iostream>
#include "Scene.h"

using namespace std;


static const int USAGE_ERR = -1;
static const int FILE_OPEN_ERR = -2;


int main( int argc, char **argv )
{
	if ( argc != 2 ) {
		cerr << "Usage: raytrace <descriptor>" << endl;
		exit( USAGE_ERR );
	}

	fstream infile;
	infile.open( argv[ 1 ] );
	if ( !infile.good() ) {
		cerr << "Error: could not open file '" << argv[ 1 ] << "' for reading" << endl;
		exit( FILE_OPEN_ERR );
	}

	Scene s;
       	s.parse( infile );
	s.renderImage();
	s.saveImage();

	return 0;
}

